<?php
/**
 * Created by PhpStorm.
 * User: wanderleijunior
 * Date: 21/10/20
 * Time: 11:45
 */

namespace Repositories;

use Util\InstanceProvider;

class Logacesso
{
    /**
     * @param $cdoperador
     * @param $currentdate
     * @param $dssistema
     * @param $nrorg
     * @throws \Exception
     */
    public function create($cdoperador, $dssistema, $nrorg)
    {

        $query = <<<SQL
            INSERT INTO LOGACESSO
                        (CDOPERADOR, DTHRACESSO, DSSISTEMA, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
                 VALUES (:CDOPERADOR, SYSDATE, :DSSISTEMA, :NRORG, SYSDATE, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU)
SQL;
            $params = array(
                "CDOPERADOR" => $cdoperador,
                "DSSISTEMA" => $dssistema,
                "NRORG" => $nrorg,
                "NRORGINCLUSAO" => $nrorg,
                "CDOPERINCLUSAO" => $cdoperador,
                "NRORGULTATU" => $nrorg,
                "CDOPERULTATU" => $cdoperador
            );

        try {
            $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
            $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

            $std = $entityManager->getConnection()->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }

    public function findByOperator($cdoperador, $nrorg)
    {
        $query = "SELECT L.CDOPERADOR, L.DTHRACESSO, L.DSSISTEMA, L.IDATIVO, L.IDIMPLOGACESSO
                    FROM LOGACESSO L
                   WHERE L.NRORG = :NRORG
                     AND L.CDOPERADOR = :CDOPERADOR";

        $params = array('NRORG' => $nrorg, 'CDOPERADOR' => $cdoperador);
        try {
            $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
            $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
            $data = $entityManager->getConnection()->fetchAll($query, $params);
            return empty($data) ? $data : $data[0];
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        }
    }

    public function update($cdoperador, $nrorg)
    {
        $query = "UPDATE LOGACESSO
                     SET DTHRACESSO     = SYSDATE,
                         NRORGULTATU    = :NRORG,
                         DTULTATU       = SYSDATE,
                         CDOPERULTATU   = :CDOPERADOR
                   WHERE CDOPERADOR     = :CDOPERADOR
                     AND NRORG          = :NRORG";

        $params = array(
            'CDOPERADOR' => $cdoperador,
            'NRORG' => $nrorg
        );
        try {
            $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
            $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
            $entityManager->getConnection()->executeQuery($query, $params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
}