/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMRATEIO                                               */
/* Tabela : ITEMRATEIO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 02/05/2007 Mariana Ferreira da Costa                                       */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITEMRATEIO'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITEMRATEIO
GO

CREATE TRIGGER DTULTATU_ITEMRATEIO
ON ITEMRATEIO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ITEMRATEIO', 'CDRATEIO='    + CDRATEIO   +
                                     ';CDFILIAL='   + CDFILIAL   +
                                     ';CDCENTCUST=' + CDCENTCUST + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ITEMRATEIO
      SET DTULTATUITRT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ITEMRATEIO.CDRATEIO  ,0) = ISNULL(INSERTED.CDRATEIO  ,0)) AND
            (ISNULL(ITEMRATEIO.CDFILIAL  ,0) = ISNULL(INSERTED.CDFILIAL  ,0)) AND
            (ISNULL(ITEMRATEIO.CDCENTCUST,0) = ISNULL(INSERTED.CDCENTCUST,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ITEMRATEIO','4.11.106';
GO

